<?php 

class PsbApi {
	
	static $module_instance;

	static function test($json) {
		if(!PsbLib::_issoap())
			return self::$module_instance->l('Brak modułu PHP-soap - połączenie nie będzie działać');
		
		$pass = $json['pass'] ? $json['pass'] : PsbLib::getConf('PATRONBROKER_API_PASS');
		$params = array(
			"token" => array(
				"UserName" => $json['user'],
				"Password" => $pass
			)			
		);
		$ret = self::call('GetServicesInfo', $params, null, $json['url']);
		if($ret === false) {
			$err = Patronbroker::$errors;
			Patronbroker::$errors = null;
			return $err;
		}
		if(psb_debug) error_log(print_r($ret, true));
		
		if(!isset($ret->GetServicesInfoResult->responseDescription) || ($ret->GetServicesInfoResult->responseDescription != 'Success')) return 'Błąd API: ' . $ret->GetServicesInfoResult->responseDescription;
		if(!isset($ret->GetServicesInfoResult->Services->ServiceInfo) || empty($ret->GetServicesInfoResult->Services->ServiceInfo)) return 'Brak usług';
		return 'OK';
	}
	
	static function getOrg($json) {
		$pass = $json['pass'] ? $json['pass'] : PsbLib::getConf('PATRONBROKER_API_PASS');
		$params = array(
			"token" => array(
				"UserName" =>  $json['user'],
				"Password" =>  $pass
			)
		);
		$ret = self::call('GetServicesInfo', $params, null, $json['url']);
		if($ret === false) {
			$err = Patronbroker::$errors;
			Patronbroker::$errors = null;
			return $err;
		}
		if(psb_debug) error_log(print_r($ret, true));
		
		if(!isset($ret->GetServicesInfoResult->responseDescription) || ($ret->GetServicesInfoResult->responseDescription != 'Success')) return 'Błąd API: ' . $ret->GetServicesInfoResult->responseDescription;
		if(is_object($ret->GetServicesInfoResult->Services->ServiceInfo)) $ret->GetServicesInfoResult->Services->ServiceInfo = array($ret->GetServicesInfoResult->Services->ServiceInfo);
		
		PsbLib::configFromApi($json['group'], $json['shop'], trim($json['url']), $json['user'], $json['pass'], $ret->GetServicesInfoResult->Services->ServiceInfo);
		return 'OK';
	}
	
	static function createLabelJson($json) {
		if(psb_debug) error_log('json=' . print_r($json, true));
		$resp = self::createLabel($json['id_order'], $json['patronbroker_kwota'], $json['patronbroker_adres'], $json['patronbroker_kod'], $json['patronbroker_miasto'], $json['patronbroker_uwagi'], $json['patronbroker_ubezp'], null, null, null, null, null, $json['paczki']);
		return $resp;
	}
	
	static function createLabel($id_order, $kwota = 'undefined', $i_adr = 'undefined', $i_kod = 'undefined', $i_mi = 'undefined', $i_uwg = 'undefined', $i_ubezp = 'undefined', $i_waga = 'undefined', $i_dlug = 'undefined', $i_szer = 'undefined', $i_wys = 'undefined', $i_nst = 0, $paczki = null) {
		try {
			if(!PsbLib::_issoap()) {
				Patronbroker::$errors[] = 'Brak modułu PHP-soap';
				if(psb_debug) error_log('brak mod');
				return false;
			}
			$log = "";
			$order = new Order((int)$id_order);
			$log .= print_r($order, true);
			$customer = new Customer((int)$order->id_customer);
			$log .= print_r($customer, true);
			// 		$cart = new Cart((int)$order->id_cart);
			//		$log .= print_r($cart, true);
			$shop = new Shop($order->id_shop);
			$log .= print_r($shop, true);
			$address_r = new Address($order->id_address_delivery);
			$log .= print_r($address_r, true);
			$order_carrier = new OrderCarrier($order->getIdOrderCarrier($order));
			$log .= print_r($order_carrier, true);
			$aprod = $order->getProducts();
			$log .= print_r($aprod, true);
				
			$waga = $order_carrier->weight;
			$wys = 0;
			$szer = 0;
			$dlug = 0;
			if(count($aprod) == 1) {
				$prod = array_pop($aprod);
				$wys = $prod['height'];
				$szer = $prod['depth'];
				$dlug = $prod['width'];
			}
				
			if($waga <= 0) $waga = PsbLib::getConf('PATRONBROKER_WAGA', $order);
			if($wys <= 0) $wys = PsbLib::getConf('PATRONBROKER_WYS', $order);
			if($szer <= 0) $szer = PsbLib::getConf('PATRONBROKER_SZER', $order);
			if($dlug <= 0) $dlug = PsbLib::getConf('PATRONBROKER_DLUG', $order);
			if($waga <= 0) $waga = psb_defW;
			if($wys <= 0) $wys = psb_defH;
			if($szer <= 0) $szer = psb_defD;
			if($dlug <= 0) $dlug = psb_defL;
	
			$ubez = ($i_ubezp != 'undefined' && $i_ubezp != '' ? $i_ubezp : PsbLib::getConf('PATRONBROKER_UBEZ', $order));
			if($ubez <= 0) $ubez = 0;
			if($i_ubezp != 'undefined' && $i_ubezp != '' && !is_numeric($i_ubezp)) {
				Patronbroker::$errors[] = 'Ubezpieczenie - błędny format liczby';
				return false;
			}
			if($i_waga != 'undefined' && $i_waga != '' && !is_numeric($i_waga)) {
				Patronbroker::$errors[] = 'Waga - błędny format liczby';
				return false;
			}
			if($i_wys != 'undefined' && $i_wys != '' && !is_numeric($i_wys)) {
				Patronbroker::$errors[] = 'Wysokość - błędny format liczby';
				return false;
			}
			if($i_dlug != 'undefined' && $i_dlug != '' && !is_numeric($i_dlug)) {
				Patronbroker::$errors[] = 'Długość - błędny format liczby';
				return false;
			}
			if($i_szer != 'undefined' && $i_szer != '' && !is_numeric($i_szer)) {
				Patronbroker::$errors[] = 'Szerokość - błędny format liczby';
				return false;
			}
	
			$format = 0;
			//		$format = $this->getConfigData('labelFormat');
			if(!$format) $format = 7;
				
			$a = PsbLib::getSymById( $order->id_carrier );
			if($a == null) {
				Patronbroker::$errors[] = 'Nieidentyfikowana metoda wysyłki ' . $order->id_carrier;
				return false;
			}
			list($metoda, $iscod, $carr) = $a;
				
			$pobranie = PsbLib::getCOD($order);
			if($kwota != 'undefined' && $kwota != '') $pobranie = $kwota;
	
			$params = array(
					"token" => array(
							"UserName" => PsbLib::getConf('PATRONBROKER_API_LOGIN', $order),
							"Password" => PsbLib::getConf('PATRONBROKER_API_PASS', $order)
					),
					"createShipmentRequest" => array(
							"ServiceId" => $metoda,
							"ShipFrom" => array(
									"PointId" => "",
									"ClientTaxId" => '',
									"Name" => PsbLib::getConf('PATRONBROKER_NAD_NAZ', $order) != '' ? PsbLib::getConf('PATRONBROKER_NAD_NAZ', $order) : PsbLib::getConf('PS_SHOP_NAME', $order),
									"Address" => PsbLib::getConf('PATRONBROKER_NAD_ADR', $order) != '' ? PsbLib::getConf('PATRONBROKER_NAD_ADR', $order) : (PsbLib::getConf('PS_SHOP_ADDR1', $order) . (PsbLib::getConf('PS_SHOP_ADDR2', $order) != '' ? ' ' . PsbLib::getConf('PS_SHOP_ADDR2', $order) : '')),
									"City" => PsbLib::getConf('PATRONBROKER_NAD_MIASTO', $order) != '' ? PsbLib::getConf('PATRONBROKER_NAD_MIASTO', $order) : PsbLib::getConf('PS_SHOP_CITY', $order),
									"PostCode" => trim(PsbLib::getConf('PATRONBROKER_NAD_KOD', $order) != '' ? PsbLib::getConf('PATRONBROKER_NAD_KOD', $order) : PsbLib::getConf('PS_SHOP_CODE', $order)),
									"CountryCode" => 'PL',
									"Person" => PsbLib::getConf('PATRONBROKER_NAD_OSOBA', $order) != '' ? PsbLib::getConf('PATRONBROKER_NAD_OSOBA', $order) : PsbLib::getConf('PS_SHOP_NAME', $order),
									"Contact" => PsbLib::getConf('PATRONBROKER_NAD_TEL', $order) != '' ? PsbLib::getConf('PATRONBROKER_NAD_TEL', $order) : PsbLib::getConf('PS_SHOP_PHONE', $order),
									"Email" => PsbLib::getConf('PATRONBROKER_NAD_EMAIL', $order) != '' ? PsbLib::getConf('PATRONBROKER_NAD_EMAIL', $order) : PsbLib::getConf('PS_SHOP_EMAIL', $order),
									"IsPrivatePerson" => false
							),
							"ShipTo" => array(
									"PointId" => "",
									"ClientTaxId" => $address_r->vat_number,
									"Name" => $address_r->company != '' ? $address_r->company : $address_r->firstname . ' ' . $address_r->lastname,
									"Address" => $i_adr != 'undefined' ? $i_adr : ($address_r->address1 . ($address_r->address2 != '' ? (' ' . $address_r->address2) : '')),
									"City" => $i_mi != 'undefined' ? $i_mi : $address_r->city,
									"PostCode" => trim($i_kod != 'undefined' ? $i_kod : $address_r->postcode),
									"CountryCode" => 'PL',
									"Person" => ($address_r->firstname . $address_r->lastname) != '' ? $address_r->firstname . ' ' . $address_r->lastname : $address_r->company,
									"Contact" => $address_r->phone_mobile != '' ? $address_r->phone_mobile : $address_r->phone,
									"Email" => $customer->email,
									"IsPrivatePerson" => true
							),
							"Parcels" => isset($paczki) ? array() : array(
									"Parcel" => array(
											"Type" => 'Package',
											"Weight" => $i_waga != 'undefined' && $i_waga != '' ? $i_waga : $waga,
											"D" => $i_dlug != 'undefined' && $i_dlug != '' ? $i_dlug : $dlug,
											"W" => $i_wys != 'undefined' && $i_wys != '' ? $i_wys : $wys,
											"S" => $i_szer != 'undefined' && $i_szer != '' ? $i_szer : $szer,
											"IsNST" => ($i_nst == 1)
									)
							),
							"COD" => array(
									"Amount" => $pobranie,
									"RetAccountNo" => 0
							),
							"InsuranceAmount" => $pobranie != 0 ? $pobranie : $ubez,
							"MPK" => "",
							"ContentDescription" => $i_uwg != 'undefined' ? $i_uwg : PsbLib::genUwagi($order),
							"rabateCoupon" => 0,
							"LabelFormat" => 'PDF',
							"AdditionalServices" => array()
					)
			);
			if(isset($paczki)) {
				$params['createShipmentRequest']['Parcels']['Parcel'] = array();
				foreach($paczki as $paka) {
					$params['createShipmentRequest']['Parcels']['Parcel'][] = array(
							"Type" => 'Package',
							"Weight" => $paka['waga'],
							"D" => $paka['dlug'],
							"W" => $paka['wys'],
							"S" => $paka['szer'],
							"IsNST" => $paka['nst']
					);
				}
			}
			if(PsbLib::getConf('PATRONBROKER_REQ_MAIL', $order)) $params['ShipmentRequest']['AdditionalServices']['AdditionalService'][] = array('Code' => 'EMAIL');
			if(PsbLib::getConf('PATRONBROKER_REQ_SMS', $order)) $params['ShipmentRequest']['AdditionalServices']['AdditionalService'][] = array('Code' => 'SMS');
			 
			$response = self::call("CreateShipment", $params, $order);

			if(!isset($response->CreateShipmentResult->responseDescription) || ($response->CreateShipmentResult->responseDescription != 'Success')) {
				if(psb_debug) error_log(print_r($response, true));
				Patronbroker::$errors[] = "Błąd API: " . '[' . $response->CreateShipmentResult->responseCode . '] ' . $response->CreateShipmentResult->responseDescription;
				return false;
			}
			$api_id = $response->CreateShipmentResult->ParcelData->Label->ParcelID;
			$track = $response->CreateShipmentResult->ParcelData->Label->ParcelID;
			if(isset($response->CreateShipmentResult->ParcelData->Label->MimeData)) $response->CreateShipmentResult->ParcelData->Label->MimeData = "[" . strlen($response->CreateShipmentResult->ParcelData->Label->MimeData) . "]";	// Aby w logu nie było śmieci
			if(psb_debug) error_log(print_r($response, true));
			$order_carrier->tracking_number = $api_id;
			$order_carrier->update();
			$order->shipping_number = $api_id;
			$order->update();
			$resp = array();
			$resp[] = PsbLib::savePdf($order, '', $track, $api_id);
			$resp[] = PsbLib::genTrackLink($api_id);
			return $resp[0] ? $resp : false;
		} catch(Exception $e) {
			Patronbroker::$errors[] = "Order #$id_order: " . $e->getMessage();
			return false;
		}
	}

	static function getLabelPdfApi($api_parcel_id, $order) {
		$a = PsbLib::getSymById( $order->id_carrier );
		if($a == null) {
			if(psb_debug) error_log('Nieznana metoda ' . $order->id_carrier);
			return false;
		}
		list($metoda, $iscod, $carr) = $a;
		
		$params = array(
			"token" => array(
				"UserName" => PsbLib::getConf('PATRONBROKER_API_LOGIN', $order),
				"Password" => PsbLib::getConf('PATRONBROKER_API_PASS', $order)
			),
			"request" => array(
				'RequestedLabels' => array(
					'PackagesByCarrier' => array(
						'Carrier' => $carr,
						"PackageNo" =>  array(
							"string" => $api_parcel_id
						)
					)
				),
				'MimeFormat' => 'PDF'
			)
		);

		$response = self::call("GetLabel", $params, $order);

		if(!isset($response->GetLabelResult->responseDescription) || ($response->GetLabelResult->responseDescription != 'Success')) {
			if(psb_debug) error_log(print_r($response, true));
			return false;
		}
		if(is_array($response->GetLabelResult->LabelData->Label)) {
			$pdfs = array();
			$tr = array();
			foreach($response->GetLabelResult->LabelData->Label as $label) {
				$pdfs[] = $label->MimeData;
				$label->MimeData = "[" . strlen($label->MimeData) . "]";	// Aby w logu nie było śmieci
			}
			$pdf = new Zend_Pdf();
			foreach($pdfs as $p) {
				$pdf1 = Zend_Pdf::parse($p);
				foreach ($pdf1->pages as $page) {
					$pdf->pages[] = clone $page;
				}
			}
	
			$shippingLabelContent = $pdf->render();
		}
		else {
			$shippingLabelContent = $response->GetLabelResult->LabelData->Label->MimeData;
			$response->GetLabelResult->LabelData->Label->MimeData = "[" . strlen($shippingLabelContent) . "]";	// Aby w logu nie było śmieci
		}
		if(psb_debug) error_log(print_r($response, true));
		return $shippingLabelContent;
	}
	
	static function updateOrder($order) {
		echo "&nbsp;Order " . $order->id . "<br/>";
		$order_carrier = new OrderCarrier((int)$order->getIdOrderCarrier());
	
		$url = trim(PsbLib::getConf('PATRONBROKER_API_URL', $order));
		if(!is_string($url) || (substr($url, 0, 4) != "http")) $url = 'https://apiopennet.patronbrokerservice.pl/api.asmx?WSDL';
		$client = new SoapClient($url);
	
		$params = array(
			"token" => array(
				"UserName" => PsbLib::getConf('PATRONBROKER_API_LOGIN', $order),
				"Password" => PsbLib::getConf('PATRONBROKER_API_PASS', $order)
			),
			"packageNo" => $order_carrier->tracking_number
		);
		$log = print_r($params, true);
		if(psb_debug) error_log($log);
	
		$response = self::call("GetTracking", $params, $order);
		if(psb_debug) error_log(print_r($response, true));
		if(!isset($response->GetTrackingResult->responseDescription) || ($response->GetTrackingResult->responseDescription != 'Success')) {
			echo "&nbsp;&nbsp;ERR: [" . $response->GetTrackingResult->responseCode . '] ' . $response->GetTrackingResult->responseDescription . "<br/>";
			return 0;
		}
		$stat = $response->GetTrackingResult->CurrentStatus->Code;
		echo "&nbsp;&nbsp;Status: $stat<br/>";
		if($stat != 'DOR') return 0;
	
		$history = new OrderHistory();
		$history->id_order = $order->id;
		//$current_order_state = $order->getCurrentOrderState();
		$order_state = new OrderState(self::upd_to);
		//$history->id_employee = (int)$this->context->employee->id;
	
		$use_existings_payment = false;
		if (!$order->hasInvoice()) {
			$use_existings_payment = true;
		}
		$history->changeIdOrderState((int)$order_state->id, $order, $use_existings_payment);
	
		$carrier = new Carrier($order->id_carrier, $order->id_lang);
		$templateVars = array();
		if($history->id_order_state == Configuration::get('PS_OS_SHIPPING') && $order->shipping_number) {
			$templateVars = array('{followup}' => str_replace('@', $order->shipping_number, $carrier->url));
		}
		$history->addWithemail(true, $templateVars);
	
		return 1;
	}
	
	static function call($meth, $params, $order = null, $url = null) {
		if($url == null) {
			$url = trim(PsbLib::getConf('PATRONBROKER_API_URL', $order));
			if(!is_string($url) || (substr($url, 0, 4) != "http")) $url = psb_testurl;
		}
		if(psb_debug) error_log("URL=$url");
		try {
			if(psb_debug) error_log(print_r($params, true));
			$client = new SoapClient($url);
			
			$response = $client->__soapCall($meth, array($params));
		} catch (Exception $e) {
			Patronbroker::$errors = $e->getMessage();
			return false;
		}
		return $response;
	}

}

?>
