<?php 

class PsbLib {
	
	static $module_instance;
	static $zabronione = array(95, 123, 173);
	static $pass = 'Patronbroker';
	
	static function createTables() {
		$sql = '
        	CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_. 'patronbroker_label'.'` (
            `id_label` int(11) NOT NULL AUTO_INCREMENT,
            `id_order` int(11) NOT NULL,
            `pdf` mediumblob,
            `api_parcel_id` varchar(255) NOT NULL,
            `api_tracking` varchar(255) NOT NULL,
            `date_ins` datetime NOT NULL,
            `date_upd` datetime NOT NULL,
            PRIMARY KEY (`id_label`),
            UNIQUE KEY `id_order` (`id_order`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8';
		if(!Db::getInstance()->execute($sql)) return false;
		return true;
	}
	
	static function assignGroups($carrier) {
		$groups = array ();
		foreach ( Group::getGroups ( ( int ) Context::getContext ()->language->id ) as $group )
			$groups [] = $group ['id_group'];
	
		if (version_compare ( _PS_VERSION_, '1.5.5', '<' )) {
			if (! self::setGroupsOld ( ( int ) $carrier->id, $groups ))
				return false;
		} else {
			if (! $carrier->setGroups ( $groups ))
					return false;
		}
		return true;
	}
	
	static function setGroupsOld($id_carrier, $groups) {
		foreach ( $groups as $id_group )
			if (! Db::getInstance ()->execute ( '
            	INSERT INTO `' . _DB_PREFIX_ . 'carrier_group` (`id_carrier`, `id_group`)
                VALUES ("' . ( int ) $id_carrier . '", "' . ( int ) $id_group . '")
             	' ))
				return false;
		return true;
	}
	
	static function findZoneId() {
		$zones = Zone::getZones(true);
		foreach ($zones as $z)
			if($z['name'] == 'Polska') return $z['id_zone'];
		foreach ($zones as $z)
			if($z['name'] == 'Poland') return $z['id_zone'];
		foreach ($zones as $z)
			if($z['name'] == 'Europe') return $z['id_zone'];
		return 1;
	}
	
	static function createZone($id_carrier) {
		return DB::getInstance ()->Execute ( '
        	INSERT INTO `' . _DB_PREFIX_ . 'carrier_zone`
            (`id_carrier`, `id_zone`)
            VALUES
            ("' . ( int ) $id_carrier . '", "' . self::findZoneId() . '")' );
	}
	
	static function createDelivery($id_carrier, $id_range, $cod) {
		return DB::getInstance ()->Execute ( '
        	INSERT INTO `' . _DB_PREFIX_ . 'delivery`
            (`id_carrier`, `id_range_weight`, `id_zone`, `price`)
            VALUES
            ("' . ( int ) $id_carrier . '", "' . ( int ) $id_range . '", "' . self::findZoneId() . '", "' . ($cod ? psb_defCodPrice : psb_defPrice) . '")' );
	}
	
	
	static function installTab() {
		$id_parent = (int)Tab::getIdFromClassName('AdminParentShipping');
		if(!$id_parent) return false;
	
		$tab = new Tab();
		$tab->active = 1;
		$tab->class_name = 'AdminPsb';
		$tab->name = array();
	
		foreach (Language::getLanguages(true) as $lang)
			$tab->name[$lang['id_lang']] = 'Patron Broker';
	
		$tab->id_parent = $id_parent;
		$tab->module = 'patronbroker';
		return $tab->add();
	}
	
	static function removeZone($id_carrier) {
		return DB::getInstance()->Execute('
        	DELETE FROM `'._DB_PREFIX_.'carrier_zone`
            WHERE `id_carrier` = "'.(int)$id_carrier.'"
        	');
	}
	
	static function uninstallTab() {
		$id_tab = (int)Tab::getIdFromClassName('AdminPatronbroker');
	
		if($id_tab) {
			$tab = new Tab($id_tab);
			return $tab->delete();
		}
		//else return false;
		return true;
	}
	
	static function getConf($n, $order = null) {
		return Configuration::get($n, null, null, $order ? $order->id_shop : null);
	}
	
	static function configFromApi($group, $shop, $url, $user, $pass, $aserv) {
		if($group == '') $group = 0;
		if($shop == '') $shop = 0;
		Configuration::updateGlobalValue ( 'PATRONBROKER_API_LOGIN', $user );
		if($pass) Configuration::updateGlobalValue ( 'PATRONBROKER_API_PASS', $pass );
		Configuration::updateGlobalValue ( 'PATRONBROKER_API_URL', $url );
		$del_carr = unserialize( Configuration::getGlobalValue('PATRONBROKER_SERV'));
	
		$adds = array();
		foreach($aserv as $serv) {
			$sym = $serv->ID;
			$name = $serv->Name;
			$carr = $serv->Carrier;
//			if( !in_array($sym, self::$dozwolone_serv) ) continue;

			$cod = true;
			if($serv->AdditionalServicesInfo) {
				if(is_object($serv->AdditionalServicesInfo->AdditionalServiceInfo)) $serv->AdditionalServicesInfo->AdditionalServiceInfo = array($serv->AdditionalServicesInfo->AdditionalServiceInfo);
				foreach ($serv->AdditionalServicesInfo->AdditionalServiceInfo as $add) {
					if (!isset($adds[$add->Code])) $adds[$add->Code] = array();
					$adds[$add->Code][] = $sym;
//					if ($add->id == 'cod') $cod = true;
				}
			}
			$stat1 = false;
			$stat2 = false;
			try {
				$stat1 = self::createCarrier($sym, $name, $name, false, $carr);
				if($stat1 && $cod) $stat2 = self::createCarrier($sym, $name, $name, true, $carr);
			} catch(Exception $e) {}
			if(!$stat1 || ($cod && !$stat2)) continue;
			unset($del_carr[$sym]);
			$a = unserialize( Configuration::get( 'PATRONBROKER_PRICE', null, $group, $shop ) );
			if( !isset($a[$sym][0]) ) $a[$sym][0] = psb_defPrice;
			if( $cod && !isset($a[$sym][1]) ) $a[$sym][1] = psb_defCodPrice;
			Configuration::updateValue( 'PATRONBROKER_PRICE', serialize($a), null, $group, $shop );
		}
		Configuration::updateGlobalValue( 'PATRONBROKER_ADDS', serialize($adds) );
		self::log('adds=' . print_r($adds, true));

		foreach ($del_carr as $cc) self::deleteCarrier($cc);
	}

	static function createCarrier($sym, $name, $desc, $cod, $carr) {
		self::log('createCarrier sym=' . $sym . ' n=' . $name . ' cod=' . ($cod?1:0));
		if(in_array($sym, self::$zabronione)) return false;
		$cc = self::getCarrierConf($sym);
		$id = null;
		if( !empty($cc) ) $id = (int) ($cod ? (isset($cc['id_cod']) ? $cc['id_cod'] : null) : (isset($cc['id']) ? $cc['id'] : null));
		$id = self::createCarrierPresta($id, $name, $desc, $cod);
		if( $id === false ) return false;
		 
		$plik = _PS_SHIP_IMG_DIR_.'/' . $id . '.jpg';
		if(!file_exists($plik)) copy(_PS_MODULE_DIR_ . '/patronbroker/views/img/logo-mini.jpg' , $plik);
		 
		if ($cod) $cc['id_cod'] = $id;
		else $cc['id'] = $id;
		 
		$cc['sym'] = $sym;
		$cc['name'] = $name;
		$cc['name_en'] = $name;
		$cc['desc'] = '';
		$cc['carr'] = $carr;
		return self::setCarrierConf( $sym, $cc );
	}

	static function createCarrierPresta($id, $name, $desc, $cod) {
		$carrier = new Carrier( (int)$id );
		if ($id && Validate::isLoadedObject ( $carrier ))
			if (! $carrier->deleted)
				return $id;
			else {
				$carrier->deleted = 0;
				if ($carrier->save ()) return $id;
				else return false;
			}
	
		$lang = new Language((int) Configuration::get ( 'PS_LANG_DEFAULT' ));
		if(($lang->iso_code == 'pl') && isset($desc['pl'])) $name = $desc;
		//if(($lang->iso_code == 'en') && isset($desc['en'])) $name = $desc['en'];
		//if(($lang->iso_code == 'gb') && isset($desc['en'])) $name = $desc['en'];
	
		$n = $cod ? substr($name, 0, 53) . self::$module_instance->l(' - pobranie') : substr($name, 0, 64);
		$carrier = new Carrier ();
		$carrier->name = $n;
		$carrier->active = 1;
		$carrier->is_free = 0;
		$carrier->shipping_handling = 1;
		$carrier->shipping_external = 1;
		$carrier->shipping_method = 1;
		$carrier->max_width = psb_maxL;
		$carrier->max_height = psb_maxH;
		$carrier->max_depth = psb_maxD;
		$carrier->max_weight = psb_maxW;
		$carrier->grade = 0;
		$carrier->is_module = 1;
		$carrier->need_range = 1;
		$carrier->range_behavior = 1;
		$carrier->external_module_name = 'patronbroker';
		$carrier->url = psb_trackUrl;
	
		$delay = array ();
		$n = $desc;
		foreach ( Language::getLanguages ( false ) as $language ) {
			$iso_code = $language['iso_code'];
			//if($iso_code == 'gb') $iso_code = 'en';
			//if(isset($desc[$iso_code])) $n = $desc[$iso_code];
			//elseif(($iso_code == 'pl') && isset($desc['pl'])) $n = $desc['pl'];
			//elseif(isset($desc['en'])) $n = $desc['en'];
			$delay [$language ['id_lang']] = $n;
		}
		$carrier->delay = $delay;
	
		if (! $carrier->save ())
			return false;
	
		$range_obj = $carrier->getRangeObject ();
		$range_obj->id_carrier = ( int ) $carrier->id;
		$range_obj->delimiter1 = 0;
		$range_obj->delimiter2 = psb_maxW;
		if (! $range_obj->save ())
			return false;
	
		if (! self::assignGroups ( $carrier ))
			return false;
		if (! self::createZone ( $carrier->id ))
			return false;
		if (! self::createDelivery ( $carrier->id, $range_obj->id, $cod ))
			return false;
	
		self::log('createCarrierPresta id=' . $carrier->id);
		return $carrier->id;
	}
	
	static function deleteAllCarriers() {
		$a = unserialize( Configuration::getGlobalValue ( 'PATRONBROKER_SERV' ) );
		foreach ($a as $cc) if(!self::deleteCarrier($cc)) return false;
		return true;
	}
	
	static function deleteCarrier($cc) {
		self::log('deleteCarrier sym=' . $cc['sym']);
		if( !self::deleteCarrierPresta($cc['id'])) return false;
		if( isset($cc['id_cod']) && !self::deleteCarrierPresta($cc['id_cod'])) return false;
		 
		return self::delCarrierConf($cc['sym']);
	}

	static function deleteCarrierPresta($id) {
		if (! $id) return true;
		$carrier = new Carrier( (int)$id );
		if (! Validate::isLoadedObject ( $carrier ))
			return true;
		if ($carrier->deleted)
			return true;
	
		self::log('deleteCarrierPresta id=' . $id);
		$carrier->deleted = 1;
		return ( bool ) $carrier->save ();
	}
	
	static function createConfig() {
		if(!Configuration::updateGlobalValue('PATRONBROKER_SERV', serialize(array()))) return false;
		if (Configuration::getGlobalValue ('PATRONBROKER_HASCONFIG' )) return true;
		if(!Configuration::updateGlobalValue('PATRONBROKER_SERVARCH', serialize(array()))) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_PRICE', serialize(array()))) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_API_LOGIN', "demo")) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_API_PASS', "demo")) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_API_URL', psb_testurl)) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_UBEZ', 0)) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_WAGA', psb_defW)) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_DLUG', psb_defL)) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_SZER', psb_defD)) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_WYS', psb_defH)) return false;
		if(!Configuration::updateGlobalValue('PATRONBROKER_HASCONFIG', 1)) return false;
		return true;
	}

	static function getCarrierConf($sym) {
		$a = unserialize( Configuration::getGlobalValue ( 'PATRONBROKER_SERV' ) );
		if(isset($a[$sym])) return $a[$sym];
		return array();
	}
	
	static function setCarrierConf($sym, $cc ) {
		self::log('setCarrierConf sym=' . $sym . ' id=' . $cc['id'] . (isset($cc['id_cod']) ? ' id_cod=' . $cc['id_cod'] : ''));
		$a = unserialize( Configuration::getGlobalValue ( 'PATRONBROKER_SERV' ) );
		$a[$sym] = $cc;
		return Configuration::updateGlobalValue ( 'PATRONBROKER_SERV', serialize( $a ) );
	}
	
	static function delCarrierConf($sym) {
		self::log('delCarrierConf sym=' . $sym);
		$a = unserialize( Configuration::getGlobalValue ( 'PATRONBROKER_SERV' ) );
		unset( $a[$sym] );
		return Configuration::updateGlobalValue ( 'PATRONBROKER_SERV', serialize( $a ) );
	}
	
	static function getSymById($id) {
		$a = unserialize( Configuration::getGlobalValue ( 'PATRONBROKER_SERV' ) );
		foreach ($a as $k => $w) {
			if(isset($w['id']) && ($w['id'] == $id)) return array($k, false, $w['carr']);
			if(isset($w['id_cod']) && ($w['id_cod'] == $id)) return array($k, true, $w['carr']);
		}
		$a = unserialize( Configuration::getGlobalValue ( 'PATRONBROKER_SERVARCH' ) );
		if(isset($a[$id]['sym'])) return array($a[$id]['sym'], $a[$id]['cod'], $w['carr']);
		return null;
	}
	
	static function genUwagi($order) {
		$ret = PsbLib::getConf('PATRONBROKER_REQ_REF', $order) ? 'Zamówienie ' . $order->reference : '';
	
		if(PsbLib::getConf('PATRONBROKER_ZAW', $order)) {
			$oprod = array();
			$aprod = $order->getProducts();
			foreach($aprod as $prod) {
				if(psb_debug) error_log(print_r($prod, true));
				$oprod[] = $prod['product_name'] . ($prod['product_quantity'] != 1 ? ' (' . $prod['product_quantity'] . ' szt)' : '');
			}
			$ret .= ($ret ? ' / ' : '') . implode(', ', $oprod);
		}
	
		return $ret;
	}
	
	static function genTrackLink($track) {
		$ret = '<a target="_blank" class="_blank" href="' . psb_trackUrl . '">@</a>';
		$ret = str_replace('@', $track, $ret);
		return $ret;
	}
	
	static function getTrackByOrder($id_order) {
		$row = Db::getInstance()->getRow('
        	SELECT `api_tracking`,`api_parcel_id`
            FROM `'._DB_PREFIX_.'patronbroker_label`
            WHERE `id_order`='.(int)$id_order
				);
		//        error_log(print_r($row, true));
		//    	$ret = $row['api_tracking'];
		$ret = $row['api_parcel_id'];
		//    	if(!$ret) $ret = $row['api_parcel_id'];
		return $ret;
	}
	
	static function savePdf($order, $pdf, $track, $api_id) {
		$id = PsbLib::getLabelByOrder($order->id);
	
		$epdf = DB::getInstance()->_escape($pdf);
		$pdf_sql = '"' . $epdf . '"';
	
		if($id) {	// Update
			//			if(PsbLib::getConf('PATRONBROKER_NBUFOR', $order)) $pdf_sql = 'NULL';
			if(!DB::getInstance()->Execute('
        		UPDATE `'._DB_PREFIX_.'patronbroker_label` SET
           		`pdf`=' . $pdf_sql . ',
           		`api_parcel_id`="' . $api_id . '",
           		`api_tracking`="' . $track . '",
           		`date_upd`=now()
           		WHERE id_label=' . $id . '
            	')) {
	            	Patronbroker::$errors[] = 'Database error 1!';
	            	return false;
			}
			return $id;
		}
		// Insert
		if(!DB::getInstance()->Execute('
        	INSERT INTO `'._DB_PREFIX_.'patronbroker_label`
            (`id_order`, `pdf`, `api_parcel_id`, `api_tracking`, `date_ins`, `date_upd`)
            VALUES
            ("' . (int)$order->id . '",
           	' . $pdf_sql . ',
           	"' . $api_id . '",
           	"' . $track . '",
    		now(),
           	now()
            )')) {
	            Patronbroker::$errors[] = 'Database error 2!';
	            return false;
		}
	
		return self::getLabelByOrder($order->id);
	}
	
	static function getLabelByOrder($id_order) {
		return Db::getInstance()->getValue('
        	SELECT `id_label`
            FROM `'._DB_PREFIX_.'patronbroker_label`
            WHERE `id_order`='.(int)$id_order
				);
	}
	
	static function getLabelPdf($id_label) {
		$row = Db::getInstance()->getRow('
        	SELECT `id_order`,`pdf`,`api_parcel_id`
            FROM `'._DB_PREFIX_.'patronbroker_label`
            WHERE `id_label`='.(int)$id_label
		);
		$id_order = $row['id_order'];
		$order = new Order((int)$id_order);
		$label = PsbApi::getLabelPdfApi($row['api_parcel_id'], $order);

		return $label;
	}
	
	static function doUpdate($pass) {
		if($pass != self::pass) return;
		echo "Update<br/>";
		$sql = '
        	SELECT `id_order`
            FROM `'._DB_PREFIX_.'orders`
            WHERE `current_state`=' . self::upd_from . '
            AND id_carrier in (SELECT id_carrier FROM `'._DB_PREFIX_.'carrier` WHERE name regexp \'patronbroker\')';
		//		echo "sql=$sql<br/>";
		$rows = DB::getInstance()->executeS($sql, false);
		$n = 0;
		foreach($rows as $row) {
			$order = new Order($row[0]);
			$n += PsbApi::updateOrder($order);
		}
		echo "Updated $n rows<br/>";
	}
		
	static function getCOD($order) {
		$pobranie = 0;
		//		if(psb_debug) error_log(print_r($order, true));
		if($order->module == 'cashondelivery') $pobranie = $order->total_products_wt + $order->total_shipping_tax_incl + $order->total_wrapping_tax_incl - $order->total_discounts;
		return $pobranie;
	}
	
	static function _issoap() {
		return extension_loaded('soap');
	}
	
	static function log($txt) {
		if(psb_debug) error_log($txt);
	}
	
}

?>