{extends file="helpers/form/form.tpl"}

{block name="input"}
	{if $input.name == 'PATRONBROKER_API_ACTIONS'}
    	<div id="patronbroker_api_actions" class="form-horizontal">
			<div id="patronbroker_msg_container"></div>
        	<table cellspacing="0" cellpadding="10" class="table">
            	<tbody>
                	<tr>
                    	<td><button class="btn btn-default pull-left" id="patronbroker_test_api" type="button">{l s='Sprawdź połączenie' mod='patronbroker'}</button></td>
                    	<td><button class="btn btn-default pull-left" id="patronbroker_get_org" type="button" style="display: none;">{l s='Pobierz listę usług' mod='patronbroker'}</button></td>
                    </tr>
                </tbody>
            </table>
	    </div>
	    <script type="text/javascript">

	    var patronbroker_ajax_uri = '{$input.ajax_uri|escape:'htmlall':'UTF-8'}';
	    var patronbroker_token = '{$input.token|escape:'htmlall':'UTF-8'}';
	    var patronbroker_group = '{$input.group|escape:'htmlall':'UTF-8'}';
	    var patronbroker_shop = '{$input.shop|escape:'htmlall':'UTF-8'}';

	    $(document).ready(function(){
			$('#patronbroker_test_api').live('click', function() {
				$('#ajax_running').slideDown();
				$('#patronbroker_msg_container').slideUp().html('');
		        $.ajax({
		            type: "POST",
		            async: true,
		            url: patronbroker_ajax_uri,
		            dataType: "json",
		            global: false,
		            contentType: "application/json; charset=utf-8",
		            data: JSON.stringify({
		            	'action': 'test',
		            	'token': patronbroker_token,
		            	'url': $('#PATRONBROKER_API_URL').val(),
		            	'user': $('#PATRONBROKER_API_LOGIN').val(),
		            	'pass': $('#PATRONBROKER_API_PASS').val()
		            }),
		            success: function(resp)
		            {
						if (resp.error)
						{
							$('#patronbroker_get_org').hide();
							$('#patronbroker_msg_container').hide().html('<p class="error alert alert-danger">'+resp.error+'</p>').slideDown();
						}
						else
						{
							$('#patronbroker_get_org').show();
							$('#patronbroker_msg_container').hide().html('<p class="alert alert-success">'+resp.ok+'</p>').slideDown();
						}
						$.scrollTo('#patronbroker_api_actions', 400, { offset: { top: -100 }});

		                $('#ajax_running').slideUp();
		            },
		            error: function(jqXHR, textStatus, errorThrown)
		            {
		            	if(jqXHR.status == 0) alert("{l s='Nieprawidłowa domena' mod='patronbroker'}");
		                $('#ajax_running').slideUp();
		            }
		        });
			});
		    
			$('#patronbroker_get_org').live('click', function() {
				$('#ajax_running').slideDown();
				$('#patronbroker_msg_container').slideUp().html('');
		        $.ajax({
		            type: "POST",
		            async: true,
		            url: patronbroker_ajax_uri,
		            dataType: "json",
		            global: false,
		            contentType: "application/json; charset=utf-8",
		            data: JSON.stringify({
		            	'action': 'get_org',
		            	'token': patronbroker_token,
		            	'group': patronbroker_group,
		            	'shop': patronbroker_shop,
		            	'url': $('#PATRONBROKER_API_URL').val(),
		            	'user': $('#PATRONBROKER_API_LOGIN').val(),
		            	'pass': $('#PATRONBROKER_API_PASS').val()
		            }),
		            success: function(resp)
		            {
						if (resp.error)
						{
							$('#patronbroker_msg_container').hide().html('<p class="error alert alert-danger">'+resp.error+'</p>').slideDown();
							$.scrollTo('#patronbroker_api_actions', 400, { offset: { top: -100 }});
						}
						else
						{
							location = location.href;
						}

		                $('#ajax_running').slideUp();
		            },
		            error: function(jqXHR, textStatus, errorThrown)
		            {
		            	if(jqXHR.status == 0) alert("{l s='Nieprawidłowa domena' mod='patronbroker'}");
		                $('#ajax_running').slideUp();
		            }
		        });
			});
	    });
	    
		</script>
	{elseif $input.name == 'PATRONBROKER_PRICE'}
    	<div id="patronbroker_price" class="form-horizontal">
        	<table cellspacing="0" cellpadding="10" class="table">
        		<thead>
        			<tr>
        				<th>{l s='Usługa' mod='patronbroker'}</th>
        				<th>{l s='Cena' mod='patronbroker'}</th>
        				<th>{l s='Cena z COD' mod='patronbroker'}</th>
        			</tr>
        		</thead>
            	<tbody>
            	{foreach $fields_value[$input.name] as $k => $r}
                	<tr>
                    	<td>{$input.serv[$k][{$input.field}]}</td>
                    	<td><input type="text" id="{$input.name}_{$k}_0" name="{$input.name}[{$k}][0]" maxlength="6" value="{$r[0]}" /></td>
                    	<td>{if isset($r[1])}<input type="text" id="{$input.name}_{$k}_1" name="{$input.name}[{$k}][1]" maxlength="6" value="{$r[1]}" />{/if}</td>
                    </tr>
                {/foreach}
                </tbody>
            </table>
	    </div>
	    <script type="text/javascript">

	    function testRanges() {
    	    if( $('#PATRONBROKER_RANGES_on').is(':checked')) {
    	        $("#patronbroker_price").hide();
    	    } else {
    	        $("#patronbroker_price").show();
    	    }
	    }

	    $(document).ready(function(){

			testRanges();
	    	$('#PATRONBROKER_RANGES_on').click(function() {
		    	testRanges();
	    	});
	    	
	    });
	    
		</script>
	{else}
		{$smarty.block.parent}
    {/if}

{/block}
